/*
Proyecto Final para la Clase de Microcomputadoras

Integrantes:
Aquino Terrazas Fernando
Campos Fuentes Jair Alejandro

PORTD(0) = Reloj
PORTD(1) = Data

*/

//Encabezados
#include <16f877.h>

#fuses HS,NOPROTECT,
#use delay(clock=20000000)
#use rs232(baud=9600, xmit=PIN_C6, rcv=PIN_C7)
#org 0x1F00, 0x1FFF void loader16F877(void) {} //for the 8k 16F876/7

//Definiciones

#byte    PORTB =  0x06
#byte    PORTD =  0x08
#byte    TRISB =  0x86
#byte    TRISD =  0x88
#byte    PORTE =  0x09

#define  RS       2
#define  RW       1
#define  E        0



int cont=0;
int DATA11[11], DATA, i, k=0,disp=1;
char buffer[16];


void LCD(void);            // Funcion de inicializacion del LCD
void fncEscribe(char car);   // Funcion que escribe un caracter en la LCD
void fnc(int );      // Funcion para teclas especiales (Enter, BackSpace, Space, Escape)
void lista(void);         // Funcion para Letras, teclado numerico, simbolos.
void fncOpe(int);
void compara(void);
void limpia(void);

//Cuerpo
void main()
{

   //Bits 0 y 1 del puerto D como entrada
   bit_set(TRISD,0);
   bit_set(TRISD,1);
   //Puerto B como salida
   set_tris_b(0x00);
   //Puerto E como salida
   set_tris_e(0x00);

    LCD();

    i=8;

   //Condicion Inicial
   //Todos los puertos en 0
    output_b(0x00);
   output_e(0x00);


   //Redardo para que todo se estabilice
   delay_ms(1000);

   while(1)
   {
      while(bit_test(PORTD,0)==1);
      DATA11[cont++] = bit_test(PORTD,1);
      while(bit_test(PORTD,0)==0);


      if(cont==11)
      {
         int i;
         cont=0;

         for(i=1;i<=8;i++)
         {
            if(DATA11[i]==1)
               bit_set(DATA,8-i);
            else
               bit_clear(DATA,8-i);

         }

         if(DATA==0x0F){     //Si es diferente del Codigo de Liberacion de Tecla
         delay_ms(5);
                      }

         if(DATA!=0x0F)       //Si es diferente del Codigo de Liberacion de Tecla

           if(DATA!=0x5A)
           lista();       //Permite que se visualicen los caracteres
           else if(DATA==0x5A)
           compara();
      }
   }//while
}//main

// Funcion de inicializacion del LCD
void LCD(void)
{
   //-----------------------------------//
   //Rutina de Inicializacion de la LCD //
   //-----------------------------------//

   //1.  Retardo de 16ms para que todos
   //    los voltajes se estabilizen.

   delay_ms(16);        //Retardo de 16ms

   //2.-

   //Nota: Siempre que se manda un comando
   //la terminal de control debe ser puesta a 1 (E=1)
   //y luego rehresada a cero (E=0)

   bit_set(PORTE,E);    //E=1
   output_b(0x30);      //PORTB = 30H
   bit_clear(PORTE,E);  //E=0

   //3.
   delay_ms(5);         //Retardo de 5ms

   //4.
   bit_set(PORTE,E);    //E=1
   output_b(0x30);      //PORTB = 30H
   bit_clear(PORTE,E);  //E=0

   //5.
   delay_us(105);       //Retardo de 105us

   //6.
   bit_set(PORTE,E);    //E=1
   output_b(0x30);      //PORTB = 30H
   bit_clear(PORTE,E);  //E=0

   //x.

   //Ahora debe haber retardos de 2ms entre cada
   //cada instruccion para que puedan ser leidos
   //por la LCD.

   delay_ms(2);         //Retardo de 2ms

   //7.Function Set
   bit_set(PORTE,E);    //E=1
   output_b(0x38);      //PORTB = 38H
   bit_clear(PORTE,E);  //E=0

   delay_ms(2);         //Retardo de 2ms

   //8.Display Off
   bit_set(PORTE,E);    //E=1
   output_b(0x08);      //PORTB = 08H
   bit_clear(PORTE,E);  //E=0

   delay_ms(2);         //Retardo de 2ms

   //9.Display Clear
   bit_set(PORTE,E);    //E=1
   output_b(0x01);      //PORTB = 01H
   bit_clear(PORTE,E);  //E=0

   delay_ms(2);         //Retardo de 2ms

   //10. Entry Mode Set
   bit_set(PORTE,E);    //E=1
   output_b(0x06);      //PORTB = 06H
   bit_clear(PORTE,E);  //E=0

   delay_ms(2);         //Retardo de 2ms

   //-----------------------------------//
   //Fin de la Inicializacion de la LCD //
   //-----------------------------------//

   //Enciende el display//
   bit_set(PORTE,E);    //E=1
   output_b(0x0C);      //PORTB = 0CH
   bit_clear(PORTE,E);  //E=0
   delay_ms(2);         //Retardo de 2ms

   //Escribe en el display//
    bit_clear(PORTE,RS);      //RS=0
    bit_clear(PORTE,RW);      //RW=0
    //fncOpe(0x84);
    PORTE =  0x80;
    
}

//Funcion que escribe un caracter en la LCD
void fncEscribe(char car)
{
      bit_set(PORTE,E);    //E=1
      output_b(car);       //PORTB = car
      bit_clear(PORTE,E);  //E=0
      delay_us(50);
}

//Funcion para teclas especiales
void fncOpe(int ope)
{
      bit_set(PORTE,E);    //E=1
      output_b(ope);       //PORTB = car
      bit_clear(PORTE,E);  //E=0
      delay_us(50);
}

// Funcion para Letras, teclado numerico, simbolos
void lista(void)
{
   //Pasar a modo dato
   bit_set(PORTE,RS);      //RS=1
   bit_clear(PORTE,RW);    //RW=0

         if(DATA==0x38)
              {fncEscribe('A');
              buffer[k]='A';
              }
            else if(DATA==0x4C){
              fncEscribe('B');
              buffer[k]='B';
              }
            else if(DATA==0x84){
              fncEscribe('C');
              buffer[k]='C';
              }
            else if(DATA==0xC4){
              fncEscribe('D');
              buffer[k]='D';
              }
            else if(DATA==0x24){
              fncEscribe('E');
              buffer[k]='E';
              }
            else if(DATA==0xD4){
              fncEscribe('F');
              buffer[k]='F';
              }
            else if(DATA==0x2C){
              fncEscribe('G');
              buffer[k]='G';
              }
            else if(DATA==0xCC){
              fncEscribe('H');
              buffer[k]='H';
              }
            else if(DATA==0xC2){
              fncEscribe('I');
              buffer[k]='I';
              }
            else if(DATA==0xDC){
              fncEscribe('J');
              buffer[k]='J';
              }
            else if(DATA==0x42){
              fncEscribe('K');
              buffer[k]='K';
              }
           else if(DATA==0xD2){
              fncEscribe('L');
              buffer[k]='L';
              }
           else if(DATA==0x5C){
              fncEscribe('M');
              buffer[k]='M';
              }
           else if(DATA==0x8C){
              fncEscribe('N');
              buffer[k]='N';
              }
           else if(DATA==0x32){
              fncEscribe('@');
              buffer[k]='@';
              }
           else if(DATA==0x22){
              fncEscribe('O');
              buffer[k]='O';
              }
           else if(DATA==0xB2){
              fncEscribe('P');
              buffer[k]='P';
              }
           else if(DATA==0xA8){
              fncEscribe('Q');
              buffer[k]='Q';
              }
           else if(DATA==0xB4){
              fncEscribe('R');
              buffer[k]='R';
              }
           else if(DATA==0xD8){
              fncEscribe('S');
              buffer[k]='S';
              }
           else if(DATA==0x34){
              fncEscribe('T');
              buffer[k]='T';
              }
           else if(DATA==0x3C){
              fncEscribe('U');
              buffer[k]='U';
              }
           else if(DATA==0x54){
              fncEscribe('V');
              buffer[k]='V';
              }
           else if(DATA==0xB8){
              fncEscribe('W');
              buffer[k]='W';
              }
           else if(DATA==0x44){
              fncEscribe('X');
              buffer[k]='X';
              }
           else if(DATA==0xAC){
              fncEscribe('Y');
              buffer[k]='Y';
              }
           else if(DATA==0x58){
              fncEscribe('Z');
              buffer[k]='Z';
              }

      //Teclas del area de teclado numerico

           else if(DATA==0x0E){
              fncEscribe('0');
              buffer[k]='0';
              }
           else if(DATA==0x96){
              fncEscribe('1');
              buffer[k]='1';
              }
           else if(DATA==0x4E){
              fncEscribe('2');
              buffer[k]='2';
              }
           else if(DATA==0x5E){
              fncEscribe('3');
              buffer[k]='3';
              }
           else if(DATA==0xD6){
              fncEscribe('4');
              buffer[k]='4';
              }
           else if(DATA==0xCE){
              fncEscribe('5');
              buffer[k]='5';
              }
           else if(DATA==0x2E){
              fncEscribe('6');
              buffer[k]='6';
              }
           else if(DATA==0x36){
              fncEscribe('7');
              buffer[k]='7';
              }
           else if(DATA==0xAE){
              fncEscribe('8');
              buffer[k]='8';
              }
           else if(DATA==0xBE){
              fncEscribe('9');
              buffer[k]='9';
              }
           else if(DATA==0x8E){
              fncEscribe('.');
              buffer[k]='.';
              }
           else if(DATA==0x9E){
              fncEscribe('+');
              buffer[k]='+';
              }
           else if(DATA==0xDE){
              fncEscribe('-');
              buffer[k]='-';
              }
           else if(DATA==0x3E){
              fncEscribe('*');
              buffer[k]='*';
              }
           else if(DATA==0xA4){
              fncEscribe('$');
              buffer[k]='$';
              }

               //Tecla especial para Enter
               if(DATA==0x5A){
                  bit_clear(PORTE,RS);    //RS=0
                  bit_clear(PORTE,RW);    //RW=0
                  fncOpe(0xC0);
                             }


               //Tecla especial para BackSpace
               if(DATA==0x66){
                  bit_clear(PORTE,RS);     //RS=0
                  bit_clear(PORTE,RW);     //RW=0
                  fncOpe(0x10);
                  bit_set(PORTE,RS);      //RS=1
                  bit_clear(PORTE,RW);    //RW=0
                  fncEscribe(' ');
                  bit_clear(PORTE,RS);      //RS=0
                  bit_clear(PORTE,RW);      //RW=0
                  fncOpe(0x10);
                  buffer[k]='#';
                  k=k-1;
                          }
               //Tecla especial para Space
               if(DATA==0x94){
                  bit_set(PORTE,RS);      //RS=1
                  bit_clear(PORTE,RW);    //RW=0
                  fncEscribe(' ');
                          }

               //Tecla especial para Escape
               if(DATA==0x6E){
                  bit_clear(PORTE,RS);      //RS=0
                  bit_clear(PORTE,RW);      //RW=0
                  fncOpe(0x01);
                  delay_ms(50);
                  bit_clear(PORTE,RS);      //RS=0
                  bit_clear(PORTE,RW);      //RW=0
                  //fncOpe(0x84);
                  PORTE =  0xC0;
                  k=-1;
                             }

               //Tecla especial para F1(Corrimiento a la Izquierda)
               if(DATA==0xA0){
                     bit_clear(PORTE,RS);    //RS=0
                     bit_clear(PORTE,RW);    //RW=0
                     fncOpe(0x18);
                             }

               //Tecla especial para F12(Corrimiento a la Derecha)
               if(DATA==0xE0){
                     bit_clear(PORTE,RS);   //RS=0
                     bit_clear(PORTE,RW);   //RW=0
                     fncOpe(0x1C);
                             }
               //Tecla especial para F8(Enciende/Apaga el LCD)
               if(DATA==0x50){
                  if(disp==1){
                     bit_clear(PORTE,RS);   //RS=0
                     bit_clear(PORTE,RW);   //RW=0
                     fncOpe(0x0A); //Apaga
                     disp=0;
                  }else if(disp==0){
                     bit_clear(PORTE,RS);   //RS=0
                     bit_clear(PORTE,RW);   //RW=0
                     fncOpe(0x0C); //Prende
                     disp=1;
                  }
               }
               //Tecla especial para F7
               if(DATA==0xC1){
                     bit_clear(PORTE,RS);   //RS=0
                     bit_clear(PORTE,RW);   //RW=0
                     fncOpe(0x0C);//Enciende
                             }
                //     if(DATA==0xD0){ cursoron
                 //    bit_clear(PORTE,RS);   //RS=0
                  //   bit_clear(PORTE,RW);   //RW=0
                    // fncOpe(0x0E);//Enciende
                      // }
//}
                  delay_ms(5);
                  k=k+1;
}

void compara(){

char blinkon[7]={'B','L','I','N','K','O','N'};
char blioff[8]={'O','F','F','B','L','I','N','K'};
char curon[8]={'C','U','R','S','O','R','O','N'};
char curof[9]={'O','F','F','C','U','R','S','O','R'};
char clear[5]={'C','L','E','A','R'};
char dispon[9]={'D','I','S','P','L','A','Y','O','N'};
char dispof[10]={'D','I','S','P','L','A','Y','O','F','F'};

    if(buffer[0]==clear[0]){
     if(buffer[1]==clear[1])
      if(buffer[2]==clear[2])
       if(buffer[3]==clear[3])
        if(buffer[4]==clear[4]){
             bit_clear(PORTE,RS);   //RS=0
             bit_clear(PORTE,RW);   //RW=0
             fncOpe(0x01);
             limpia();
            }
   }

   if(buffer[0]==dispon[0]){
    if(buffer[1]==dispon[1])
     if(buffer[2]==dispon[2])
      if(buffer[3]==dispon[3])
       if(buffer[4]==dispon[4])
        if(buffer[5]==dispon[5])
         if(buffer[6]==dispon[6])
          if(buffer[7]==dispon[7])
           if(buffer[8]==dispon[8])
            {
             bit_clear(PORTE,RS);   //RS=0
             bit_clear(PORTE,RW);   //RW=0
             fncOpe(0x0C);
             limpia();
             disp=1;
            }
   }

    if(buffer[0]==dispof[0]){
     if(buffer[1]==dispof[1])
      if(buffer[2]==dispof[2])
       if(buffer[3]==dispof[3])
        if(buffer[4]==dispof[4])
         if(buffer[5]==dispof[5])
          if(buffer[6]==dispof[6])
           if(buffer[7]==dispof[7])
            if(buffer[8]==dispof[8])
             if(buffer[9]==dispof[9]) 
             {
             bit_clear(PORTE,RS);   //RS=0
             bit_clear(PORTE,RW);   //RW=0
             fncOPE(0x08);
             limpia();
             disp=0;
            }

}

   if(buffer[0]==curon[0]){
    if(buffer[1]==curon[1])
     if(buffer[2]==curon[2])
      if(buffer[3]==curon[3])
       if(buffer[4]==curon[4]){
        if(buffer[5]==curon[5])
         if(buffer[6]==curon[6])
          if(buffer[7]==curon[7])
             bit_clear(PORTE,RS);   //RS=0
             bit_clear(PORTE,RW);   //RW=0
             fncOpe(0x0E);
             limpia();
            }
   }

   if(buffer[0]==curof[0]){
    if(buffer[1]==curof[1])
     if(buffer[2]==curof[2])
      if(buffer[3]==curof[3])
       if(buffer[4]==curof[4])
        if(buffer[5]==curof[5])
         if(buffer[6]==curof[6])
          if(buffer[7]==curof[7])
           if(buffer[8]==curof[8])
             {
             bit_clear(PORTE,RS);   //RS=0
             bit_clear(PORTE,RW);   //RW=0
             fncOpe(0x0C);
             limpia();
             }
            
   }
   if(buffer[0]==blinkon[0]){
    if(buffer[1]==blinkon[1])
     if(buffer[2]==blinkon[2])
      if(buffer[3]==blinkon[3])
       if(buffer[4]==blinkon[4])
        if(buffer[5]==blinkon[5])
         if(buffer[6]==blinkon[6])
             bit_clear(PORTE,RS);   //RS=0
             bit_clear(PORTE,RW);   //RW=0
             fncOpe(0x0F);
             limpia();
         
            
   }
   if(buffer[0]==blioff[0]){
    if(buffer[1]==blioff[1])
     if(buffer[2]==blioff[2])
      if(buffer[3]==blioff[3])
       if(buffer[4]==blioff[4])
        if(buffer[5]==blioff[5])
         if(buffer[6]==blioff[5])
          if(buffer[7]==blioff[7])
        limpia();
            {
             bit_clear(PORTE,RS);   //RS=0
             bit_clear(PORTE,RW);   //RW=0
             fncOpe(0x0C);
             limpia();
            }
   }
}

void limpia(){
   int m;
   for(m=0;m<16;m++)
   buffer[m]=' ';

   k=0;
}

